<?php

namespace InSegment\WorkersFramework\Traits;

use Shavshukov\EventAppBase\MicroEvent;
use Shavshukov\EventAppBase\Service\ErrorReport;

trait EventsTrait
{
    /**
     * Register event
     * 
     * @param string $event
     * @param callable $callback
     * @return null
     */
    public function on($event, callable $callback)
    {
        MicroEvent::registerEvent(static::class, $event, $callback);
    }
    
    /**
     * Trigger event
     * 
     * @param string $event
     * @param array $args
     * @return bool
     */
    protected function trigger($event, ...$args)
    {
        try {
            return MicroEvent::fireEvent(static::class, $event, ...$args);
        } catch (\Throwable $e) {
            ErrorReport::report($e, false);
        }
    }
}
